# -*- coding: utf-8 -*-
"""
Модуль обновления ПО через svn

(c)2013 ЗАО "РИПАС",
www.ripas.ru
"""

if __name__ == "__main__":
    import sys,os
    if sys.platform.startswith('linux'):
        if os.fork()>0:
            exit(0)
    import psutil
    main_process=None
    try:
        main_process=psutil.Process(int(sys.argv[2]))
    except psutil.NoSuchProcess:
        main_process=None
    if main_process:
        try:
            main_process.wait(10)
        except psutil.TimeoutExpired:
            main_process.kill()
    del main_process,psutil

    update_complete=False
    if sys.platform[:3]=='win':
        print('Запуск обновления '+sys.argv[3])
        path_list=os.environ['PATH'].split(';')
        for p in path_list:
            tp=os.path.join(p,'TortoiseProc.exe')
            if os.path.exists(tp):
                import subprocess
                subprocess.call(tp+' /command:update /path:"%s"'%sys.argv[3])
                update_complete=True
                break
    else:
        print('Запуск обновления '+sys.argv[3])
    if not update_complete:
        try:
            import pysvn
            client=pysvn.Client()
            client.set_interactive(False)
            client.set_default_username(None if sys.argv[4]=='' else sys.argv[4])
            client.set_default_password(None if sys.argv[5]=='' else sys.argv[5])
            revision=client.update(sys.argv[3])[0]
            if revision.number<0:
                print('Ошибка')
            else:
                print('Обновлено до ревизии %d'%revision.number)
        except:
            print(sys.exc_info())
    from subprocess import Popen
    #Popen([sys.argv[1]]).wait()
    Popen([sys.argv[1]],cwd=os.path.dirname(sys.argv[1]))
    sys.exit(0)
